Attribute VB_Name = "Funcao17"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'A API abaixo trava todas as opes de um form
'ou s as que voc desejar que ele trave

'OBS: esta API tambm  vlida para forms MDI
Public Enum OpcoesForm
    Maximizar = 1
    Tamanho = 2
    Mover = 3
    Minimizar = 4
    Restaurar = 5
    Fechar = 6
End Enum

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Const SW_SHOWNORMAL = 1
 
Private Const SC_MAXIMIZE = &HF030
Private Const SC_MINIMIZE = &HF020
Private Const SC_MOVE = &HF010
Private Const SC_RESTORE = &HF120
Private Const SC_SIZE = &HF000
Private Const SC_CLOSE = &HF060
Private Const MF_BYCOMMAND = 0

Private Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Private Declare Function DeleteMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

'Para travar as opes use esta funo
Public Sub TravarOpcoes(Opcao As OpcoesForm, gForm As Form)
    Dim hMenu As Long
    hMenu = GetSystemMenu(gForm.hwnd, 0)

    Select Case Opcao
        Case 1
            Call DeleteMenu(hMenu, SC_MAXIMIZE, MF_BYCOMMAND) 'trava o Maximixar
        Case 2
            Call DeleteMenu(hMenu, SC_SIZE, MF_BYCOMMAND) 'trava o tamanho
        Case 3
            Call DeleteMenu(hMenu, SC_MOVE, MF_BYCOMMAND) 'trava o mover
        Case 4
            Call DeleteMenu(hMenu, SC_MINIMIZE, MF_BYCOMMAND) 'trava o minimizar
        Case 5
            Call DeleteMenu(hMenu, SC_RESTORE, MF_BYCOMMAND) 'trava o restaurar
        Case 6
            Call DeleteMenu(hMenu, SC_CLOSE, MF_BYCOMMAND) 'trava o fechar ( X )
    End Select

End Sub

