Attribute VB_Name = "Funcao26"
'por: HELIO CANDIDO

'Funes melhoradas por mim

'O cdigo abaixo faz mapeamentos da rede atual (WIN OU WIN NT)

Private Type NETRESOURCE
    dwScope As Long
    dwType As Long
    dwDisplayType As Long
    dwUsage As Long
    lpLocalName As String
    lpRemoteName As String
    lpComment As String
    lpProvider As String
End Type

Private Const NO_ERROR = 0
Private Const CONNECT_UPDATE_PROFILE = &H1
Private Const RESOURCETYPE_DISK = &H1
Private Const RESOURCETYPE_PRINT = &H2
Private Const RESOURCETYPE_ANY = &H0
Private Const RESOURCE_CONNECTED = &H1
Private Const RESOURCE_REMEMBERED = &H3
Private Const RESOURCE_GLOBALNET = &H2
Private Const RESOURCEDISPLAYTYPE_DOMAIN = &H1
Private Const RESOURCEDISPLAYTYPE_GENERIC = &H0
Private Const RESOURCEDISPLAYTYPE_SERVER = &H2
Private Const RESOURCEDISPLAYTYPE_SHARE = &H3
Private Const RESOURCEUSAGE_CONNECTABLE = &H1
Private Const RESOURCEUSAGE_CONTAINER = &H2

Private Declare Function WNetAddConnection2 Lib "mpr.dll" Alias _
"WNetAddConnection2A" (lpNetResource As NETRESOURCE, _
ByVal lpPassword As String, _
ByVal lpUserName As String, _
ByVal dwFlags As Long) As Long
'
Private Declare Function WNetCancelConnection2 Lib "mpr.dll" Alias _
"WNetCancelConnection2A" (ByVal lpName As String, _
ByVal dwFlags As Long, _
ByVal fForce As Long) As Long

'OBS.: A FUNO ABAIXO FAZ O MAPEAMENTO DA REDE
Public Sub MapearRede(Drive As String, LocalHost As String, Senha As String, NomeDoUsuario As String)

Dim NetR As NETRESOURCE
Dim Conexao As Long

NetR.dwScope = RESOURCE_GLOBALNET
NetR.dwType = RESOURCETYPE_DISK
NetR.dwDisplayType = RESOURCEDISPLAYTYPE_SHARE
NetR.dwUsage = RESOURCEUSAGE_CONNECTABLE
NetR.lpLocalName = Drive
NetR.lpRemoteName = LocalHost

Conexao = WNetAddConnection2(NetR, Senha, NomeDoUsuario, CONNECT_UPDATE_PROFILE)

If Conexao = NO_ERROR Then
    MsgBox "Mapeamento executado com sucesso!!!", vbInformation, "Mapeando Rede"
Else
    MsgBox "Erro ao executar conexo, VERIFIQUE!!!", vbCritical, "Erro: " & Str(Conexao)
End If

End Sub

'OBS.: A FUNO ABAIXO FAZ A DESCONEXO DA REDE
Public Sub DesconectarRede(Drive As String)
Dim Conexao As Long
Dim strLocalName As String

strLocalName = Drive
Conexao = WNetCancelConnection2(strLocalName, CONNECT_UPDATE_PROFILE, False)

If Conexao = NO_ERROR Then
    MsgBox "Desconexo feita com sucesso!!!", vbInformation, "Desconectar Rede"
Else
    MsgBox "Houve uma falha ao tentar se desconectar, VERIFIQUE!!!", vbCritical, "Erro: " & Str(Conexao)
End If

End Sub
