Attribute VB_Name = "Funcao52"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Este cdigo adicionar um efeito 3D, em Relevo, em um form
'muito interessante

Public Enum OpcoesRelevo
    Alto = 1
    Baixo = 2
End Enum

'Para utilizar o efeito utilize a funo abaixo
Public Sub EfeitoForm(gForm As Object, Intensidade As Integer, Relevo As OpcoesRelevo)

    Select Case Relevo
        Case 1
            gForm.ScaleMode = 3 ' Pixels
            FormBevelLines gForm, 0, Intensidade, QBColor(15) 'White
            FormBevelLines gForm, 1, Intensidade, QBColor(8) 'D.Gray
            FormBevelLines gForm, 2, Intensidade, QBColor(15) 'White
            FormBevelLines gForm, 3, Intensidade, QBColor(8) 'D.Gray
        Case 2
            gForm.ScaleMode = 3 ' Pixels
            FormBevelLines gForm, 0, BevelWidth, QBColor(8) 'D.Gray
            FormBevelLines gForm, 1, BevelWidth, QBColor(15) 'White
            FormBevelLines gForm, 2, BevelWidth, QBColor(8)
            FormBevelLines gForm, 3, BevelWidth, QBColor(15)
    End Select
    
End Sub


Private Sub FormBevelLines(FormFrame As Object, side, wid, color)
       Dim X1, Y1, X2, Y2 As Integer
       Dim rightX, bottomY
       Dim dx1, dx2, dy1, dy2 As Integer
       Dim i
       
       rightX = FormFrame.ScaleWidth - 1
       bottomY = FormFrame.ScaleHeight - 1
       
       Select Case side
        Case 0 'Left side
            X1 = 0: dx1 = 1
            X2 = 0: dx2 = 1
            Y1 = 0: dy1 = 1
            Y2 = bottomY + 1: dy2 = -1
        Case 1 'Right side
            X1 = rightX: dx1 = -1
            X2 = X1: dx2 = dx1
            Y1 = 0: dy1 = 1
            Y2 = bottomY + 1: dy2 = -1
        Case 2 'Top side
            X1 = 0: dx1 = 1
            X2 = rightX: dx2 = -1
            Y1 = 0: dy1 = 1
            Y2 = 0: dy2 = 1
        Case 3 'Bottom side
            X1 = 1: dx1 = 1
            X2 = rightX + 1: dx2 = -1
            Y1 = bottomY: dy1 = -1
            Y2 = Y1: dy2 = dy1
End Select

For i = 1 To wid
              FormFrame.Line (X1, Y1)-(X2, Y2), color
                     X1 = X1 + dx1
                     X2 = X2 + dx2
                     Y1 = Y1 + dy1
                     Y2 = Y2 + dy2
Next

End Sub
