Attribute VB_Name = "Funcao56"
'por: HELIO CANDIDO

'Funo de minha autoria

'Esta funo imprime dentro de um quadro qualquer frase sem a mscara que aparece
'no fundo do texto

Public Enum QBCores
    Preto = 0
    Roxo = 1
    Verde_Escuro = 2
    Verde_Musgo = 3
    Marron = 4
    Lilas = 5
    Caramelo = 6
    Cinza_Claro = 7
    Cinza_Escuro = 8
    Azul_Escuro = 9
    Verde_Claro = 10
    Azul_Celeste = 11
    Vermelho = 12
    Rosa = 13
    Amarelo = 14
    Branco = 15
End Enum

Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function GetBkMode Lib "gdi32" (ByVal hdc As Long) As Long


Public Enum OpcoesEstiloFont
    Negrito = 1
    Normal = 2
    Italico = 3
    Negrito_Italico = 4
End Enum

Public Enum EstilosDeFundo
    EfTransparente = 1&
    EfOpaco = 2&
End Enum

'Para poder usar esta funo corretamente, declare o fundo
'transparente antes de imprimir o texto, e tambm acione a transparncia
'da fonte. Use os cdigos abaixo antes da impresso do texto no quadro:
    
'Aqui comea a parte realmente necessria para a impresso transparente

Public Sub ImprimirTextoTransparente(Objeto As Object, LocalX As Integer, LocalY As Integer, CorTexto As QBCores, FontTexto As String, TamanhoFont As Single, OpcoesEstilo As OpcoesEstiloFont, Texto As String)

    With Objeto
        .FontTransparent = True
        .ForeColor = QBColor(CorTexto) 'Coloque aqui a cor do texto
        
        EstiloDeFundo = EfTransparente
        
        .FontName = FontTexto
        .FONTSIZE = TamanhoFont
        
        Select Case OpcoesEstilo
            Case 1
                .FontItalic = False
                .FontBold = True
            Case 2
                .FontBold = False
                .FontItalic = False
            Case 3
                .FontBold = False
                .FontItalic = True
            Case 4
                .FontBold = True
                .FontItalic = True
        End Select
        
        .CurrentX = LocalX
        .CurrentY = LocalY
        .Print Texto
    End With
    
End Sub

Private Property Get EstiloDeFundo() As EstilosDeFundo
    EstiloDeFundo = GetBkMode(Printer.hdc)
End Property

Private Property Let EstiloDeFundo(ByVal Valor As EstilosDeFundo)
    Dim Retorno&
    Retorno = SetBkMode(Printer.hdc, Valor)
End Property

