Attribute VB_Name = "Funcao57"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'A funo abaixo usa uma barra de rolagem para
'mostrar vrios componentes em um picturebox

'Para us-la crie uma picturebox e outra
'picturebox dentro da primeira

Public Enum OpcoesScroll
    Vertical = 1
    Horizontal = 2
    Todas = 3
End Enum

'Coloque esta funo no LOAD do seu form
Public Sub DefinirArea(AreaPrincipal As PictureBox, AreaOperadora As PictureBox, Barra As OpcoesScroll, Optional BVertical As VScrollBar, Optional BHorizontal As HScrollBar)

Dim VDiff As Long
Dim HDiff As Long

VDiff = AreaPrincipal.ScaleHeight - AreaOperadora.Height
HDiff = AreaPrincipal.ScaleWidth - AreaOperadora.Width

Select Case Barra
    Case 1
        If IsNull(BVertical) Then
            MsgBox "Voc escolheu a opo de usar somente a barra vertical, mas no indicou ao sistema qual a barra, volte e indique o nome da barra que deseja usar!!!", vbCritical, "Parmetro Invlido"
            Exit Sub
        End If

        With BVertical
            .Max = Abs(VDiff)
            .LargeChange = .Max \ 10
        End With
    Case 2
        If IsNull(BHorizontal) Then
            MsgBox "Voc escolheu a opo de usar somente a barra horizontal, mas no indicou ao sistema qual a barra, volte e indique o nome da barra que deseja usar!!!", vbCritical, "Parmetro Invlido"
            Exit Sub
        End If

        With BHorizontal
            .Max = Abs(HDiff)
            .LargeChange = .Max \ 10
        End With
    Case 3
        If IsNull(BVertical) And IsNull(BHorizontal) Then
            MsgBox "Voc escolheu a opo de usar todas as barras, mas no indicou ao sistema quais so as barras, volte e indique os nomes das barras que deseja usar!!!", vbCritical, "Parmetro Invlido"
            Exit Sub
        End If

        With BVertical
            .Max = Abs(VDiff)
            .LargeChange = .Max \ 10
        End With

        With BHorizontal
            .Max = Abs(HDiff)
            .LargeChange = .Max \ 10
        End With
End Select

End Sub

'Esta funo deve ser colocada no CHANGE e no
'no SCROLL da barra de rolagem
Public Sub MostrarArea(AreaOperadora As PictureBox, Direcao As OpcoesScroll, Optional BarraVertical As VScrollBar, Optional BarraHorizontal As HScrollBar)

Select Case Direcao
    Case 1  'Move na vertical
        AreaOperadora.tOp = -BarraVertical.Value
    Case 2  'move na horizontal
        AreaOperadora.left = -BarraHorizontal.Value
End Select

End Sub

