Attribute VB_Name = "Funcao68"
'por: HELIO CANDIDO

'Esta funo (adaptada e melhorada por mim) exibe em dois
'listbox as hWnd dos programas e tambm os ttulos das
'janelas em execuo ativos, e tambm todos
'os programas que esto abertos no momento, com suas hWnd
'e seus ttulos. Permitindo tambm fechar os programas
'que voc quizer.

'Para usar esta funo coloque em um form 2 listbox
'Um ir receber os programas ativos no momento, e o outro
'ir receber todos os programas que esto abertos, inclu-
'sive os inativos

Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDLAST = 1
Private Const GW_HWNDNEXT = 2
Private Const GW_HWNDPREV = 3
Private Const GW_OWNER = 4
Private Const GW_CHILD = 5
Private Const GW_MAX = 5
Private Const SYNCHRONIZE = &H100000

Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long

'Esta funo fecha os programas que esto na lista de programas ativos
Public Sub FecharProgAtivo(ListaAtiva As ListBox, TodaLista As ListBox)
    If ListaAtiva.ListIndex < 0 Then Exit Sub
    Dim l As Long, lProc As Long
    l = ListaAtiva.ItemData(ListaAtiva.ListIndex)
    lProc = OpenProcess(SYNCHRONIZE, False, l)
    l = TerminateProcess(lProc, 0)
    l = CloseHandle(lProc)
    DoEvents
    ListaAtiva.Clear
    TodaLista.Clear
    Call ListarProgramas(ListaAtiva, TodaLista)
End Sub


'Esta funo fecha os programas que esto na lista geral
Public Sub FecharProgExecucao(ListaAtiva As ListBox, TodaLista As ListBox)
    If TodaLista.ListIndex < 0 Then Exit Sub
    Dim l As Long, lProc As Long
    l = TodaLista.ItemData(TodaLista.ListIndex)
    lProc = OpenProcess(SYNCHRONIZE, False, l)
    l = TerminateProcess(lProc, 0)
    l = CloseHandle(lProc)
    DoEvents
    ListaAtiva.Clear
    TodaLista.Clear
    Call ListarProgramas(ListaAtiva, TodaLista)
End Sub

'Esta funo lista os programas nas listbox que voc informar
Public Sub ListarProgramas(ListaAtiva As ListBox, TodaLista As ListBox)
    Dim a$, l As Long, nH As Long, mH As Long, i As Long, lProc As Long, j As Long, Found As Boolean
    mH = 128
    ReDim H(1 To mH) As Long
    l = GetDesktopWindow()
    If l Then nH = nH + 1: H(nH) = l
    l = GetWindow(l, GW_CHILD)
    Do While l
        nH = nH + 1
        If nH > mH Then mH = mH + 32: ReDim Preserve H(1 To mH) As Long
        H(nH) = l
        l = GetWindow(l, GW_HWNDNEXT)
    Loop

    a$ = Space$(128)
    For i = 1 To nH
        If GetParent(H(i)) = 0 Then
            Found = False
            l = GetWindowThreadProcessId(H(i), lProc)
            For j = 0 To ListaAtiva.ListCount - 1
                If lProc = ListaAtiva.ItemData(j) Then Found = True: Exit For
            Next
            If Not Found Then
                l = GetWindowText(H(i), a$, 128)
                If l Then
                    ListaAtiva.AddItem H(i) & "  " & Left$(a$, l)
                    ListaAtiva.ItemData(ListaAtiva.ListCount - 1) = lProc
                End If
            End If
        End If
        l = GetWindowText(H(i), a$, 128)
        TodaLista.AddItem H(i) & "  " & Left$(a$, l)
        l = GetWindowThreadProcessId(H(i), lProc)
        TodaLista.ItemData(TodaLista.ListCount - 1) = lProc
    Next
End Sub

