Attribute VB_Name = "Funcao80"
'por: HELIO CANDIDO

'Funes adaptadas por mim

'Para usar as funes faa o seguinte:

' Para Encryptar:
    'EncryptText(Texto, Senha)

'Note que os dados passados para a funo devem ser strings

' Para Decryptar:
    'DecryptText(Texto, Senha)

Option Explicit
Public Const CASE_SENSITIVE_PASSWORD = False

'Encrypta o texto
Public Function EncryptText(strText As String, ByVal strPwd As String)
    Dim i As Integer, c As Integer
    Dim strBuff As String

If Not CASE_SENSITIVE_PASSWORD Then
    strPwd = UCase$(strPwd)
End If

    If Len(strPwd) Then
        For i = 1 To Len(strText)
            c = Asc(Mid$(strText, i, 1))
            c = c + Asc(Mid$(strPwd, (i Mod Len(strPwd)) + 1, 1))
            strBuff = strBuff & Chr$(c And &HFF)
        Next i
    Else
        strBuff = strText
    End If
    EncryptText = strBuff
End Function

'Decrypta o texto encryptado anteriormente
Public Function DecryptText(strText As String, ByVal strPwd As String)
    Dim i As Integer, c As Integer
    Dim strBuff As String

If Not CASE_SENSITIVE_PASSWORD Then
    strPwd = UCase$(strPwd)
End If

    If Len(strPwd) Then
        For i = 1 To Len(strText)
            c = Asc(Mid$(strText, i, 1))
            c = c - Asc(Mid$(strPwd, (i Mod Len(strPwd)) + 1, 1))
            strBuff = strBuff & Chr$(c And &HFF)
        Next i
    Else
        strBuff = strText
    End If
    DecryptText = strBuff
End Function

