Attribute VB_Name = "Funcao42"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Os cdigos abaixo servem para dar um Flip Horizontal e Vertical em uma figura
'Em um PictureBox
Public Enum OpcoesFlip
    Horizontal = 1
    Vertical = 2
End Enum

Private Declare Function StretchBlt% Lib "GDI32" (ByVal hDC%, ByVal x%, ByVal y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal nSrcWidth%, ByVal nSrcHeight%, ByVal dwRop&)

Private Const SRCCOPY = &HCC0020
Private xX As Integer
Private yY As Integer
Private ReturnV As Integer

Public Sub FlipFigura(PicOrigem As PictureBox, PicDestino As PictureBox, Opcao As OpcoesFlip)

Select Case Opcao
    Case 1
        'Flip Horizontal
        PicOrigem.ScaleMode = 3
        PicDestino.ScaleMode = 3
        PicDestino.Cls
        xX = PicOrigem.ScaleWidth
        yY = PicOrigem.ScaleHeight
        ReturnV = StretchBlt(PicDestino.hDC, xX, 0, -xX, yY, PicOrigem.hDC, 0, 0, xX, yY, SRCCOPY)
    Case 2
        'Flip Vertical
        PicOrigem.ScaleMode = 3
        PicDestino.ScaleMode = 3
        PicDestino.Cls
        xX = PicOrigem.ScaleWidth
        yY = PicOrigem.ScaleHeight
        ReturnV = StretchBlt(PicDestino.hDC, 0, yY, xX, -yY, PicOrigem.hDC, 0, 0, xX, yY, SRCCOPY)
End Select

End Sub


