Attribute VB_Name = "Funcao47"
Option Explicit
'por: HELIO CANDIDO

'Funo adaptada e melhorada por mim

'Os cdigos abaixo escrevem uma string na posio que voc indicar

Private Type LOGFONT
  lfHeight As Long
  lfWidth As Long
  lfEscapement As Long
  lfOrientation As Long
  lfWeight As Long
  lfItalic As Byte
  lfUnderline As Byte
  lfStrikeOut As Byte
  lfCharSet As Byte
  lfOutPrecision As Byte
  lfClipPrecision As Byte
  lfQuality As Byte
  lfPitchAndFamily As Byte
'  lfFacename(LF_FACESIZE) As Byte 'THIS WAS DEFINED IN API-CHANGES MY OWN
  lfFacename As String * 33
End Type

Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'Para poder usar esse efeito use a seguinte funo

Public Sub EscreverString(Objeto As Object, gString As String, Fonte As String, Tamanho As String, Angulo As String, LocalX As Long, LocalY As Long)
  
  On Error GoTo GetOut
  
  Dim F As LOGFONT, hPrevFont As Long, hFont As Long, FontName As String
  Dim FONTSIZE As Integer
  FONTSIZE = Val(Tamanho)

  F.lfEscapement = 10 * Val(Angulo)
  FontName = Fonte + Chr$(0)
  F.lfFacename = FontName
  F.lfHeight = (FONTSIZE * -20) / Screen.TwipsPerPixelY
  hFont = CreateFontIndirect(F)
  hPrevFont = SelectObject(Objeto.hdc, hFont)
  Objeto.CurrentX = LocalX
  Objeto.CurrentY = LocalY
  Objeto.Print gString

  hFont = SelectObject(Objeto.hdc, hPrevFont)
  DeleteObject hFont

  Exit Sub
GetOut:
  Exit Sub

End Sub

