Attribute VB_Name = "Funcao49"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'O cdigo abaixo coloca um efeito 3D em Label, muito interessante, vale a pena usar

'Para usar esta funo adicione 3 labels ao seu
'projeto, no precisa modificar nenhuma propriedade
'das labels, para usar o efeito use a ltima
'funo deste mdulo. E ver como ficar interessante
'o efeito.

'Opes de cores, usadas na funo
Public Enum Cores
    Branca = &HFFFFFF
    Preto = &H0&
    Marrom = &H40&
    MarromClaro = &H404080
    VerdeMusgo = &H4000&
    AzulAlgas = &H404000
    Roxo = &H400000
    Amarelo1 = &HC0FFFF
    Amarelo2 = &H80FFFF
    Amarelo3 = &HFFFF&
    Amarelo4 = &HC0C0&
    Amarelo5 = &H8080&
    Amarelo6 = &H4040&
    Verde1 = &HC0FFC0
    Verde2 = &H80FF80
    Verde3 = &HFF00&
    Verde4 = &HC000&
    Verde5 = &H8000&
    Azul1 = &HFFFFC0
    Azul2 = &HFFC0C0
    Azul3 = &HFFFF80
    Azul4 = &HFF8080
    Azul5 = &HFFFF00
    Azul6 = &HFF0000
    Azul7 = &HC0C000
    Azul8 = &HC00000
    Azul9 = &H808000
    Azul10 = &H800000
    Lilas1 = &HFFC0FF
    Lilas2 = &HFF80FF
    Lilas3 = &HFF00FF
    Lilas4 = &HC000C0
    Lilas5 = &H800080
    Lilas6 = &H400040
    Cinza1 = &HE0E0E0
    Cinza2 = &HC0C0C0
    Cinza3 = &H808080
    Cinza4 = &H404040
    Vermelho1 = &HC0C0FF
    Vermelho2 = &H8080FF
    Vermelho3 = &HFF&
    Vermelho4 = &HC0&
    Vermelho5 = &H80&
    Laranja1 = &HC0E0FF
    Laranja2 = &H80C0FF
    Laranja3 = &H80FF&
    Laranja4 = &H40C0&
    Laranja5 = &H4080&
End Enum

Public Enum OpcoesRelevo
    Alto = 1
    Baixo = 2
End Enum

Private Const GFM_STANDARD = 0
Private Const GFM_RAISED = 1
Private Const GFM_SUNKEN = 2

Private Const GFM_BACKSHADOW = 1
Private Const GFM_DROPSHADOW = 2

Private Const BOX_WHITE& = &HFFFFFF
Private Const BOX_LIGHTGRAY& = &HC0C0C0
Private Const BOX_DARKGRAY& = &H808080
Private Const BOX_BLACK& = &H0&

Private Altern As Integer
Private Efeito3D As Integer

Private Static Sub FormLabelCaptionEmbossed(L1 As Label, L2 As Label, L3 As Label, label_text As String, label_effect As Integer, label_forecolor As Long, label_depth As Integer)

     Dim lt As String
     Dim savesm As Integer
     Dim f As Form
     Set f = L1.Parent

         L1.Visible = False
         L2.Visible = False
         L3.Visible = False

         savesm = f.ScaleMode
         f.ScaleMode = 3

         If label_text = "" Then
             lt = L1
         Else
             lt = label_text
         End If

         L1 = lt
         L2 = lt
         L3 = lt

         L1.BackStyle = 0
         L1.ForeColor = label_forecolor

         L2.Width = L1.Width
         L2.Height = L1.Height
         L2.BackStyle = L1.BackStyle

         L2.ForeColor = BOX_DARKGRAY&

         L3.Width = L1.Width
         L3.Height = L1.Height
         L3.BackStyle = L1.BackStyle

         L3.ForeColor = BOX_WHITE&

         Select Case label_effect
             Case GFM_SUNKEN
                 L2.left = L1.left - label_depth
                 L2.tOp = L1.tOp - label_depth
                 L3.left = L1.left + label_depth
                 L3.tOp = L1.tOp + label_depth
             Case GFM_RAISED
                 L2.left = L1.left + label_depth
                 L2.tOp = L1.tOp + label_depth
                 L3.left = L1.left - label_depth
                 L3.tOp = L1.tOp - label_depth

         End Select
         f.ScaleMode = savesm

         L1.Visible = True
         L2.Visible = True
         L3.Visible = True
         L1.ZOrder

End Sub


'Para usar o efeito 3D use a funo abaixo, de minha autoria

Public Sub EfeitoLabel3d(Relevo As OpcoesRelevo, ByVal LocalTop As Single, ByVal LocalLeft As Single, gString As String, gLabel1 As Label, gLabel2 As Label, gLabel3 As Label, TamanhoFont As Single, NomeFont As String, CorFace As Cores)

Efeito3D = Relevo

With gLabel1
    .tOp = LocalTop
    .left = LocalLeft
    .FONTSIZE = TamanhoFont
    .FontName = NomeFont
    .AutoSize = True
End With

With gLabel2
    .FONTSIZE = TamanhoFont
    .FontName = NomeFont
    .AutoSize = True
End With

With gLabel3
    .FONTSIZE = TamanhoFont
    .FontName = NomeFont
    .AutoSize = True
End With

GoTo Efeito
Exit Sub

Efeito:
    FormLabelCaptionEmbossed gLabel1, gLabel2, gLabel3, gString, Efeito3D, CorFace, 1
End Sub

