Attribute VB_Name = "Funcao50"
Option Explicit

'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Esta funo coloca um efeito gradiente em seu form com 4 tipos diferentes de posies

Public Enum OpcoesGradiente
    Vertical = 0
    Horizontal = 1
    Diagonal = 2
    Box = 3
End Enum
    

Public Sub Gradiente(Formulario As Form, Estilo As OpcoesGradiente)

Formulario.Line (0, 0)-(Formulario.Width, Formulario.Height), QBColor(1), BF

Dim X As Long
Dim X2 As Long

For X = 0 To 128
    'Vertically Fill
    If Estilo = 0 Then _
       Formulario.Line (0, X * Formulario.Height / 128)-(Formulario.Width, Formulario.Height), RGB(0, 0, X * 2), BF
   
   'Horizontally Fill
    If Estilo = 1 Then _
       Formulario.Line (X * Formulario.Width / 128, 0)-(Formulario.Width, Formulario.Height), RGB(0, 0, X * 2), BF
   
   'Diagonally Fill
    If Estilo = 2 Then
        For X2 = 1 To 75
            Formulario.Line (X * Formulario.Width / 64 - (X2 * 10), 0)-(0, X * Formulario.Height / 64 - (X2 * 10)), RGB(0, 0, X * 2)
        Next
    End If
   
   'Box Fill
    If Estilo = 3 Then _
       Formulario.Line (X * Formulario.Width / 256, X * Formulario.Height / 256)-(Formulario.Width - (X * Formulario.Width / 256), Formulario.Height - (X * Formulario.Height / 256)), RGB(0, 0, X * 2), BF
   
   'Bottom-Right Fill
    If Estilo = 4 Then _
       Formulario.Line (X * Formulario.Width / 128, X * Formulario.Height / 128)-(Formulario.Width, Formulario.Height), RGB(0, 0, X * 2), BF
Next

End Sub


