Attribute VB_Name = "Funcao60"
'por: HELIO CANDIDO

'Funo de minha autoria

'Esta funo retorna a quantidade de dias passados
'durante o ano a partir de uma data informada
'por voc, analisa anos normais ou bissextos,
'diferenciando os meses de 30 e 31 dias.

Public Function DiasAno(Data As String, Optional TotalDiasAno As Integer) As Integer

    'Retorna o resultado da data pesquisada
    Dim Resultado As Integer

    'Define os dias do ano
    Dim Ano As Integer
    If TotalDiasAno = 0 Then
        Ano = 365
    Else
        Ano = 366
    End If

    'Reserva o dia e o ms da data informada
    Dim Dia As Single
    Dim Mes As Single
    Dia = Int(Format(Trim(Data), "dd"))
    Mes = Int(Format(Trim(Data), "mm"))

    'Reserva o resultado do mes
    Dim MesResultado As Integer
    Select Case Mes
        Case 1
            Resultado = Dia
        Case 2
            MesResultado = Dia + 31
            Resultado = MesResultado
        Case Is > 2
            If Ano = 365 Then
                MesResultado = ((Mes - 1) * 30) - 2
            Else
                MesResultado = ((Mes - 1) * 30) - 1
            End If

            Select Case Mes
                Case 3
                    MesResultado = MesResultado + 1
                Case 4
                    MesResultado = MesResultado + 2
                Case 5
                    MesResultado = MesResultado + 2
                Case 6
                    MesResultado = MesResultado + 3
                Case 7
                    MesResultado = MesResultado + 3
                Case 8
                    MesResultado = MesResultado + 4
                Case 9
                    MesResultado = MesResultado + 5
                Case 10
                    MesResultado = MesResultado + 5
                Case 11
                    MesResultado = MesResultado + 6
                Case 12
                    MesResultado = MesResultado + 6
            End Select

            Resultado = MesResultado + Dia
    End Select

    DiasAno = Resultado
End Function

