Attribute VB_Name = "Funcao62"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Esta funo abre um combobox automaticamente
'Para us-la faa assim Call AbrirCombo(Nome do combo, Mostrar tantas linhas)

'Onde Nome do Combo deve ser o nome do combobox que voc colocou em seu programa e
'Mostrar tantas linhas  a quantidade de linhas que voc quer que seu combobox mostre
'quando estiver aberto, o mnimo  8

Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long

Private Const GW_CHILD = 5
Private Const GW_HWNDNEXT = 2
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOACTIVATE = &H10

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const CB_GETITEMHEIGHT = &H154
Private Const CB_GETDROPPEDWIDTH = &H15F
Private Const CB_SHOWDROPDOWN = &H14F

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Type SIZE
    cx As Long
    cy As Long
End Type

Private Declare Function GetWindowExtEx Lib "gdi32" (ByVal hdc As Long, lpSize As SIZE) As Long

'Use esta funo para abrir o combobox automaticamente

Public Sub AbrirCombo(Combo As ComboBox, MostrarLinhas As String)

    Dim ValorLinhas As Long
    ValorLinhas = CLng(Trim(MostrarLinhas))

    If ValorLinhas < 8 Then
        MsgBox "O valor que voc informou para mostrar as linhas do combobox  menor que o permitido, o mnimo  de 8 linhas!!!", vbCritical, "Parmetro Invlido"
    End If

    Dim i As Long, l As Long, h As Long, w As Long, f As Long, lh As Long
    Dim Rl As RECT, Rcb As RECT, S As SIZE

    On Local Error Resume Next

    w = SendMessage(Combo.hwnd, CB_GETDROPPEDWIDTH, 0, 0)
    lh = SendMessage(Combo.hwnd, CB_GETITEMHEIGHT, 0, 0)
    l = lh * (Val(MostrarLinhas) + 2)
    h = GetWindow(GetParent(Combo.hwnd), GW_CHILD)
    i = GetWindowRect(Combo.hwnd, Rcb)
    Do While h
        i = GetWindowRect(h, Rl)
        If Rl.Left = Rcb.Left And Rl.Top = Rcb.Top Then
            Exit Do
        End If
        i = GetWindow(h, GW_HWNDNEXT)
        If i = 0 Then Exit Sub
        h = i
    Loop

    f = SWP_NOMOVE + SWP_NOZORDER + SWP_NOREDRAW + SWP_NOACTIVATE

    i = SetWindowPos(h, Combo.hwnd, 0, 0, w, l, f)

    Combo.SetFocus
    i = SendMessage(Combo.hwnd, CB_SHOWDROPDOWN, True, 0)
End Sub

