Attribute VB_Name = "Funcao63"
'por: HELIO CANDIDO

'A funo abaixo (de minha autoria) abre os itens do painel de controle
'separadamente ou abre todo o painel de controle

'Coloque toda a funo abaixo em um mdulo

Public Enum OpcoesPainel
    Adicionar_Novo_Hardware = 0
    Adicionar_ou_Remover_Programas = 1
    Data_e_Hora = 2
    Propriedades_do_Video = 3
    Configuracoes_da_Internet = 4
    Joystick = 5
    Configuracoes_do_Teclado = 6
    Modem = 7
    Mouse = 8
    Multimedia = 9
    Redes = 10
    Senhas = 11
    Configuracoes_Regionais = 12
    Sons = 13
    Configuracoes_do_Sistema = 14
    Painel_de_Controle = 15
End Enum

'As funes abaixo podem estar em qualquer
'local do mdulo

'Utilize esta funo para exibir os componentes do painel de controle
Public Sub ExibirPainel(Opcao As OpcoesPainel)

Select Case Opcao
    Case 0  'Adicionar novo hardware
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl @1")
    Case 1  'Adicionar ou remover programas
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL appwiz.cpl,,1")
    Case 2  'Data e hora
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL timedate.cpl")
    Case 3  'Propriedades do vdeo
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL desk.cpl,,0")
    Case 4  'Configuraes da Internet
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,0")
    Case 5  'Joystick
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL joy.cpl")
    Case 6  'Configuraes do teclado
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL main.cpl @1")
    Case 7  'Modem
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL modem.cpl")
    Case 8  'Mouse
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL main.cpl @0")
    Case 9  'Multimedia
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,0")
    Case 10 'Redes
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL netcpl.cpl")
    Case 11 'Senhas
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL password.cpl")
    Case 12 'Configuraes Regionais
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,0")
    Case 13 'Sons
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl @1")
    Case 14 'Configuraes do sistema
        Call ControlPanels("rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl,,0")
    Case 15 'Painel de Controle - todos os componentes
        Call ControlPanels("C:\Windows\Control.Exe")
End Select

End Sub


Private Sub ControlPanels(Filename As String)
    Dim rtn As Double
    On Error Resume Next
    rtn = Shell(Filename, 5)
End Sub

