Attribute VB_Name = "Funcao66"
'por: HELIO CANDIDO

'A funo abaixo (melhorada e adaptada por mim) adiciona um efeito de
'relevo nos seus controles. Vale a pena usar,  muito boa.

'Esta funo coloca uma Borda 3D listrada em seus controles, experimente.

Public Enum OpcoesRelevo
    RelevoAlto = -1
    RelevoBaixo = 0
End Enum

Private Const CTLRECESSED = 0
Private Const CTLRAISED = -1
Private Const BKGNDGRAY = 192
Private Const DARKGRAY = 64
Private Const LIGHTGRAY = 255
Private Const DEFAULTWIDTH = 3
Private FrameWidth As Integer

'Use esta funo para dar o efeito ao controle que voc quizer
Public Sub EfeitoRelevo(gForm As Form, Controle As Control, Opcao As OpcoesRelevo, Intensidade As Single)
    Dim InOut As Integer
    InOut = Opcao
    FrameWidth = Intensidade

    InitCtl Controle, InOut
End Sub

Private Sub HighLight(C As Control, InOut As Integer)
Dim TLShade&
Dim BRShade&
Dim I%
Dim T%
Dim L%
Dim H%
Dim W%
    
    C.Parent.ScaleMode = 3
    If InOut = CTLRAISED Then
        TLShade& = RGB(LIGHTGRAY, LIGHTGRAY, LIGHTGRAY)
        BRShade& = RGB(DARKGRAY, DARKGRAY, DARKGRAY)
    Else
        TLShade& = RGB(DARKGRAY, DARKGRAY, DARKGRAY)
        BRShade& = RGB(LIGHTGRAY, LIGHTGRAY, LIGHTGRAY)
    End If
    
    For I% = 1 To FrameWidth
        T% = C.Top - I%
        L% = C.Left - I%
        H% = C.Height + 2 * I%
        W% = C.Width + 2 * I%
        C.Parent.Line (L%, T%)-Step(0, H%), TLShade&
        C.Parent.Line (L%, T%)-Step(W%, 0), TLShade&
        C.Parent.Line (L% + W%, T%)-Step(0, H%), BRShade&
        C.Parent.Line (L%, T% + H%)-Step(W%, 0), BRShade&
    Next I%
End Sub

Private Sub InitCtl(C As Control, InOut As Integer)
    If TypeOf C Is HScrollBar Then
    Else
        C.BackColor = C.Parent.BackColor
    End If
    HighLight C, InOut
End Sub
