Attribute VB_Name = "Funcao72"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'As funes abaixo desenham um relgio analgico
'dentro de uma picturebox

'Para us-la coloque duas picturebox no seu form
'e um Timer com o Interval = 1000

'No Load do form coloque a funo INICIARVALORES

'No Resize do form coloque a funo AJUSTARTAMANHO

'E no Timer coloque a funo DESENHARRELOGIO

Private CenterX As Long, CenterY As Long, MySize As Long
Private PI As Double
Private DPicture As PictureBox

Public Sub IniciarValores(gPicturePrincipal As PictureBox)
    PI = 3.14159265359
    Set DPicture = gPicturePrincipal
End Sub

Public Sub AjustarTamanho(gForm As Form, gPicturePrincipal As PictureBox, gPictureIntermediaria As PictureBox)
    gPicturePrincipal.Width = gForm.ScaleWidth - gPicturePrincipal.Left * 2
    gPicturePrincipal.Height = gForm.ScaleHeight - gPicturePrincipal.Top * 2
    CenterX = gPicturePrincipal.ScaleWidth / 2
    CenterY = gPicturePrincipal.ScaleHeight / 2
    If CenterX > CenterY Then CenterX = CenterY
    If CenterY > CenterX Then CenterY = CenterX
    MySize = CenterX / 50
    gPictureIntermediaria.Top = gPicturePrincipal.Top
    gPictureIntermediaria.Left = gPicturePrincipal.Left
    gPictureIntermediaria.Width = gPicturePrincipal.Width
    gPictureIntermediaria.Height = gPicturePrincipal.Height
End Sub

Public Sub DesenharRelogio(gForm As Form, gPicturePrincipal As PictureBox, gPictureIntermediaria As PictureBox)
    If DPicture = gPicturePrincipal Then
        Set DPicture = gPictureIntermediaria
    Else
        Set DPicture = gPicturePrincipal
    End If

    Call AjustarRelogio(gForm)
    DPicture.ZOrder 0
End Sub

Private Sub AjustarRelogio(gForm As Form)
    Dim X As Long, Y As Long, Rad As Double
    Dim X1 As Long, Y1 As Long

    DPicture.Cls

    X = CenterX

    Y = MySize * 2
    For Rad = PI * 2 To 0 Step -(PI / 6)
        X1 = Math.Cos(Rad) * (X - CenterX) + Math.Sin(Rad) * (Y - CenterY)
        Y1 = Math.Cos(Rad) * (Y - CenterY) - Math.Sin(Rad) * (X - CenterX)
        Call DrawDot(X1, Y1)
    Next

    Y = MySize * 25
    DPicture.DrawWidth = MySize / 5

    Rad = -PI / 6 * Hour(Time)
    X1 = Math.Cos(Rad) * (X - CenterX) + Math.Sin(Rad) * (Y - CenterY)
    Y1 = Math.Cos(Rad) * (Y - CenterY) - Math.Sin(Rad) * (X - CenterX)
    DPicture.Line (CenterX, CenterY)-(X1 + CenterX, Y1 + CenterY), RGB(0, 0, 0)

    Y = MySize * 4
    DPicture.DrawWidth = MySize / 10

    Rad = -PI / 30 * Minute(Time)
    X1 = Math.Cos(Rad) * (X - CenterX) + Math.Sin(Rad) * (Y - CenterY)
    Y1 = Math.Cos(Rad) * (Y - CenterY) - Math.Sin(Rad) * (X - CenterX)
    DPicture.Line (CenterX, CenterY)-(X1 + CenterX, Y1 + CenterY), RGB(100, 100, 100)

    Y = MySize * 4
    DPicture.DrawWidth = 1

    Rad = -PI / 30 * Second(Time)
    X1 = Math.Cos(Rad) * (X - CenterX) + Math.Sin(Rad) * (Y - CenterY)
    Y1 = Math.Cos(Rad) * (Y - CenterY) - Math.Sin(Rad) * (X - CenterX)
    DPicture.Line (CenterX, CenterY)-(X1 + CenterX, Y1 + CenterY), RGB(255, 0, 0)

    gForm.Caption = Format(Time, "hh:nn:ss")
End Sub

Private Sub DrawDot(X1, Y1)
    DPicture.Line ((X1 + CenterX) - MySize, (Y1 + CenterY) - MySize)-((X1 + CenterX) + MySize, (Y1 + CenterY) - MySize), RGB(255, 255, 255), B
    DPicture.Line ((X1 + CenterX) - MySize, (Y1 + CenterY) - MySize)-((X1 + CenterX) - MySize, (Y1 + CenterY) + MySize), RGB(255, 255, 255), B
    DPicture.Line ((X1 + CenterX) - MySize, (Y1 + CenterY) + MySize)-((X1 + CenterX) + MySize, (Y1 + CenterY) + MySize), RGB(0, 0, 0), B
    DPicture.Line ((X1 + CenterX) + MySize, (Y1 + CenterY) - MySize)-((X1 + CenterX) + MySize, (Y1 + CenterY) + MySize), RGB(0, 0, 0), B
End Sub

