Attribute VB_Name = "Funcao78"
'por: HELIO CANDIDO

'Funo melhorada e adaptada por mim

'Esta funo imprime um texto qualquer, fazendo
'as devidas quebras de linhas.

'Para usar esta funo use a funo WRAPTEXT

'   ***********************************************************************************
'   ***********************************************************************************
'   **                                                                               **
'   **      Exemplo da utilizao da funo para formatao de Strings quando for    **
'   **      imprimir em um relatrio                                                 **
'   **                                                                               **
'   **      WrapText Text1.Text, 1440, 4320, 1440, True                              **
'   **                                                                               **
'   **      Printer.EndDoc                                                           **
'   **                                                                               **
'   ***********************************************************************************
'   ***********************************************************************************

Public Function GetWord(txt As String) As String

    Dim pos As Integer
    
    txt = Trim$(txt)
    pos = InStr(txt, " ")
    
    If pos < 1 Then
        GetWord = txt
        txt = ""
    Else
        GetWord = Left$(txt, pos - 1)
        txt = Trim$(Right$(txt, Len(txt) - pos))
    End If
    
End Function

Public Sub NonPrintToSpace(txt As String)

    Dim i As Integer
    Dim txtlen As Integer
    Dim ch As String

    txtlen = Len(txt)
    
    For i = 1 To txtlen
        ch = Mid$(txt, i, 1)
        If ch < " " Then Mid$(txt, i, 1) = " "
    Next i
    
End Sub

Public Sub WrapText(Objeto As Object, ByVal txt As String, ByVal xmin As Single, ByVal xmax As Single, ByVal ymin As Single, ByVal draw_box As Boolean)

    Dim X As Single
    Dim Y As Single
    Dim xmargin As Single
    Dim ymargin As Single
    Dim line_wid As Single
    Dim new_line As String
    Dim new_word As String
    
    txt = txt & " @"
    
    NonPrintToSpace txt
    
    If draw_box Then
        xmargin = Objeto.TextWidth("x") / 2
        ymargin = Objeto.ScaleY(Objeto.Font.Size * 0.5, vbPoints, Objeto.ScaleMode)
        xmin = xmin + xmargin
        xmax = xmax - xmargin
        ymin = ymin + ymargin
    End If
    
    line_wid = xmax - xmin

    Objeto.CurrentY = ymin
    Objeto.CurrentX = xmin
    new_word = GetWord(txt)
    
    Do
        new_line = new_word
        
        Do
            new_word = GetWord(txt)
            If new_word = "" Then Exit Do

            If Objeto.TextWidth( _
                new_line & " " & new_word) > _
                    line_wid _
                Then Exit Do

            new_line = new_line & " " & new_word
        Loop

        Dim Verificando As Integer
        Dim caracter As String

        For Verificando = 1 To Len(new_line)
            caracter = Mid(new_line, Verificando, 2)
            
            If caracter = " @" Then
                Mid(new_line, Verificando + 1, 1) = " "
            End If
        Next
        
        Objeto.Print new_line
        If txt = "" Then Exit Do

        Objeto.CurrentX = xmin
    Loop
    
End Sub


